#ifndef BINWORDEDITOR_H
#define BINWORDEDITOR_H
#include <qvbox.h>
#include <qlineedit.h>
#include "FragBuffer.hh"

class BinWordEditor : public QVBox
{
Q_OBJECT
private:
	unsigned int *word ;
    QLineEdit *val ;
public:

	BinWordEditor(FragBuffer& mem, unsigned int index , 
    	const QString& desc, 
		  bool byteAddr, QWidget *parent) ;
    
	bool parse(const char*& desc,  QString& name, QString& doc , int& b1, int& b2) ;
	unsigned int getValue() ;
  /** No descriptions */
  void parseDoc(const char*& p, QString& doc);
signals:
	// Emmited when the word is changed
	void wordChanged() ;
private slots:
	// must be activated to synchronize hex display with bit display
    // (internal slot)
	void updateHexDisplay() ;
public slots:
	// must be activated when the word is externally changed
	void updateDisplay() ;
};

#endif
