/***************************************************************************
                          Config.h  -  description
                             -------------------
    begin                : dim dc 21 2003
    copyright            : (C) 2003 by Alain Gibaud
    email                : alain.gibaud@univ-valenciennes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H
#include <qstring.h>
#include <qstringlist.h>

/**Management of all the configuration data
  *@author Alain Gibaud
  */

class Config
{
public: 
	Config();
	~Config();
	static void getAsmConfig(QString &proc, QString &hex, QString &include, QString& radix,
	QString &warning, QString &other) ;
	static void setAsmConfig(const QString &proc,const  QString &hex,const  QString &include,const  QString& radix,
	const QString &warning,const  QString &other) ;

  static void setPortConfig(const QString &type, const QString& port, int vpp, int vdd, int clock, int dataout, int datain, int drw, int clkdelay );
  static void getCurrentPortConfig(QString &type, QString& port, int& vpp, int& vdd, int& clock, int& dataout, int& datain, int& drw, int& clkdelay )  ;
  static void getParPortConfig(QString &port, int &vpp, int& vdd, int &clock, int &dataout, int& datain, int& drw, int& clkdelay );
  static void getSerPortConfig(QString &port, int &vpp, int& vdd, int &clock, int &dataout, int& datain, int& drw, int& clkdelay );
  static void getSer555PortConfig(QString &port, int &vpp, int& vdd, int &clock, int &dataout, int& datain, int& drw, int& clkdelay );

  /** Write informations about  known programming cards */
  static void writeStdHardwares();
  /** Returns the list of std known programmers */
  static QStringList getStdHardwares();

  static void getHardConfig(const QString& name, QString &type, int& vpp, int& vdd, int& clock, int& dataout, int& datain, int& drw, int& clkdelay);
  static void setHardConfig(const QString& name, const QString &type, int vpp, int vdd, int clock, int dataout, int datain, int drw, int clkdelay) ;

  /** No descriptions */
  static void getDAsmConfig(QString& proc, bool& shortlist, QString& other);
  static void setDAsmConfig(const QString& proc, bool shortlist, const QString& other);

  /** version management */
  static void getGlobal(QString &version)   ;
  static void setGlobal(const QString &version)   ;
  /** Saves the currently opened project and files  names
   */
  static void setOpened(const QString& project, const QStringList& files);
  /** Reads the previously opened project and files names for restauration purpose */
  static void getOpened(QString& project, QStringList& files);

	
};
#endif
