/***************************************************************************
                          progressObserver.cc  -  description
                             -------------------
    begin                : dim jan 29 2006
    copyright            : (C) 2006 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "progressObserver.hh"

#include <iostream>

using namespace std ;

progressObserver::progressObserver()
{
  total_step = 0 ;
  current_step = 0 ;
  progress_value = 0 ;
  client_hook = 0 ;
}

void progressObserver::setName(const char *name)
{
  process_name = name ;
}

progressObserver::~progressObserver()
{
}

/** Used by observed routine to signal termination of a process step.
 */
int progressObserver::operator--()
{
  ++current_step ;
  int progress = (int)(100.0 * ((double)current_step / total_step)) ;
  if(progress > 100) progress = 100 ;
  if( progress > progress_value)
  {
      progress_value = progress ;
      if( client_hook ) client_hook(progress_value) ;
  }
  return progress_value ;
}
/** Connect a client to observer. As this operation must be undependant from Qt, KDE or other toolkit, connection is performed via a simple function pointer which acts as a hook.

The function pointed to by hook receive from the observer an int value normalized in [0..100].

Passing a NULL pointer is equivalent to disconnect observer object from client. */
void progressObserver::connect(void (*hook)(int) )
{
  client_hook = hook ;
}
/** Set maximal  value of step counter
    and reset current step counter
*/
int progressObserver::operator=(int total)
{
  total_step = total ;
  current_step = 0 ;
  progress_value = 0 ;
  if( client_hook ) client_hook(0) ;
  return total ;
}
/** No descriptions */
int progressObserver::operator-=(int k)
{
  current_step += (k-1) ;
  return --(*this);
}
